
use strict;

# this plots sensitivity vs PPV of Contrafold 1.1, Contrafold 2.0, Turner99 and MLbest, when measured on the 2518 structures from SSTRAND 2.0

my $eps_file = "PR_bayesbl.eps";
my $gp_file = "PR_bayesbl.gp";
my $bl = "train_1over64_S-Full-Train_bl.txt";
my $bpp = "train_1over64_S-Full-Train_bpp.txt";




my $xlabel = "PPV";
my $ylabel = "Sensitivity";

# print a tmp file.
open (GP, ">$gp_file") || die ("Cannot open $gp_file");
print GP "set terminal postscript eps color\n";
#print GP "set terminal postscript eps monochrome enhanced\n";
print GP "set output \"$eps_file\"\n";
print GP "set grid\n";
#print GP "set parametric\n";    # for the vertical bar
#print GP "set log y\n";
#print GP "set size ratio -1\n";
print GP "set size 0.7, 0.7\n";
print GP "set size square\n";
print GP "set key left bottom\n";
#print GP "set title \"Tested on S-Full\"\n";
print GP "set xlabel \"$xlabel\"\n";
print GP "set ylabel \"$ylabel\"\n";
print GP "set yrange [0.45:0.8]\n";
print GP "set xrange [0.45:0.8]\n";
#print GP "set trange [0:1]\n";
print GP "set label \"BayesBL-LA-bpp\" at graph 0.45, graph 0.75 textcolor lt 1\n";
print GP "set label \"BL-bpp\" at graph 0.2, graph 0.7 textcolor lt 4\n";
print GP "set label \"BL-mfe\" at graph 0.3, graph 0.5 textcolor lt 3\n";
#print GP "set label \"CONTRAfold\" at graph 0.55, graph 0.35\n";
#print GP "set label \"CG S-151Rfam + thermo set\" at graph 0.35, graph 0.70\n";
#print GP "set label \"CG S-151Rfam B=1.5 {/Symbol l}=200\" at graph 0.35, graph 0.70\n";
#print GP "set label \"CG S-Processed + thermo set\" at graph 0.40, graph 0.95\n";
#print GP "set label \"CG S-Processed B=10 {/Symbol l}=200\" at graph 0.40, graph 0.95\n";

# print GP "set label \"Turner99\" at graph 0.10, graph 0.52 textcolor lt 3\n";
# print GP "set label \"CONTRAfold 1.1\" at graph 0.40, graph 0.13 textcolor lt 7\n";
# print GP "set label \"CONTRAfold 2.0\" at graph 0.20, graph 0.85 textcolor lt -1\n";
# print GP "set label \"LAM-CG\" at graph 0.68, graph 0.79 textcolor lt 4\n";
# print GP "set label \"CG 1.1\" at graph 0.27, graph 0.69 textcolor lt 4\n";
# print GP "set label \"BL\" at graph 0.65, graph 0.92 textcolor lt 1\n";

print GP "plot \"$bpp\" using 3:2 notitle with linespoints lw 5 ps 1 lt 4,\\\n";
print GP "     \"$bpp\" using 5:4 notitle with linespoints lw 5 ps 1 lt 1,\\\n";
print GP "     \"$bl\" using 2:1 notitle with points ps 3 lw 5 pt 7 lt 3\n";
close (GP);
system ("gnuplot < $gp_file");
#system ("/cs/local/bin/gv $eps_file");
